var isPreventDefault = false;//for events of keyboard & mouse

function key_map(e){
//http://en.wikipedia.org/wiki/ASCII
//http://invisible-island.net/xterm/ctlseqs/ctlseqs.html#VT220-Style%20Function%20Keys
  if(isPreventDefault){
    e.preventDefault();

    if(e.charCode){

      if(!e.altKey && !e.ctrlKey){//send printable characters
        FireBBS.sendData(String.fromCharCode(e.charCode));
      }
      else if(e.altKey && !e.ctrlKey){
      }
      else if(!e.altKey && e.ctrlKey){// send control characters

        if(e.charCode == 0x32){
          FireBBS.sendData(String.fromCharCode(0x00));
        }
        else if(0x61 <= e.charCode && e.charCode <= 0x7A){
          FireBBS.sendData(String.fromCharCode(e.charCode - 0x60));
        }
        else if(0x5B <= e.charCode && e.charCode <= 0x5F){
          FireBBS.sendData(String.fromCharCode(e.charCode - 0x40));
        }
      }
      else{
         /*alert('charCode : ' + e.charCode);*/
      }
    }
    else{

      switch(e.keyCode){
        case 8://BS
          FireBBS.sendData('\x08');
          break;
        case 9://HT
          FireBBS.sendData('\x09');
          break;
        case 13://CR
          FireBBS.sendData('\x0D');
          break;
        case 27://ESC
          FireBBS.sendData('\x1B');
          break;
        case 33://Page Up
          FireBBS.sendData('\x1B[5~');
          break;
        case 34://Page Down
          FireBBS.sendData('\x1B[6~');
          break;
        case 35://End
          FireBBS.sendData('\x1B[4~');
          break;
        case 36://Home
          FireBBS.sendData('\x1B[1~');
          break;
        case 37://Arrow Left
          FireBBS.sendData('\x1B[D');
          break;
        case 38://Arrow Up
          FireBBS.sendData('\x1B[A');
          break;
        case 39://Arrow Right
          FireBBS.sendData('\x1B[C');
          break;
        case 40://Arrow Down
          FireBBS.sendData('\x1B[B');
          break;
        case 45://Insert
          FireBBS.sendData('\x1B[2~');
          break;
        case 46://DEL
          FireBBS.sendData('\x1B[3~');
          //FireBBS.sendData('\x7F');
          break;
        case 229://chinese
		    sendSingleLineOfString(e);
		    break;
		  default:
			 /*alert('keyCode : ' + e.keyCode);*/
      }
    }
  }
}
var scroll_page = 0;
var no_back = 0;
var no_click = 0;
function mouse_behavior(e){
  if(isPreventDefault){
  
    switch(e.type){
      case 'DOMMouseScroll':
        if(e.detail < 0){
          if(!scroll_page && !scroll_top_bottom){
            FireBBS.sendData('\x1B[A');
			 }else if(scroll_page && !scroll_top_bottom){
            FireBBS.sendData('\x1B[5~');
				no_back = 1;
			 }else if(!scroll_page && scroll_top_bottom){
				FireBBS.sendData('\x1B[1~');
				no_click = 1;
			 }
        }
        else{
          if(!scroll_page && !scroll_top_bottom)
            FireBBS.sendData('\x1B[B');
          else if(scroll_page && !scroll_top_bottom){
            FireBBS.sendData('\x1B[6~');
				no_back = 1;
			 }else if(!scroll_page && scroll_top_bottom){
				FireBBS.sendData('\x1B[4~');
				no_click = 1;
			 }
        }
        e.preventDefault();
        break;
      case 'contextmenu':
        if(e.target.className == 'terminal_display' && window.getSelection().isCollapsed && !no_back){
          FireBBS.sendData('\x1B[D');
          e.preventDefault();
        }else if(no_back){
			 no_back = 0;
			 e.preventDefault();
		  }
		  break;
      case 'click':
        switch(e.button){
          case 0:
            if(e.target.className == 'terminal_display' && !no_click){
              if(window.getSelection().isCollapsed){
						FireBBS.sendData('\r');
				  		e.preventDefault();
				  }
            }else if(no_click){
					no_click = 0;
			 		e.preventDefault();
				}
            break;
          default:
        }
        break;
      case 'dblclick':
        break;
		case 'mousedown':
		  if(e.button==2) scroll_page=1;
		  else if(e.button==0) scroll_top_bottom=1;
		  break;
		case 'mouseup':
		  if(e.button==2) scroll_page=0;
		  else if(e.button==0) scroll_top_bottom=0;
		  break;
      default:
    }
  }
}

function parsePTT(target){
  var reg_id = /m(\d+)n(\d+)n(\d+)/.exec(target.id);
  var m = parseInt(reg_id[1]);
  var n1 = parseInt(reg_id[2]);
  var n2 = parseInt(reg_id[3]);

  if(n1 == 24 && n2 == 25 && 13 <= m && m <= 22){//menu
    var string = target.textContent;
    if(string.search(/[A-Z]/) != -1){
      FireBBS.sendData(string + '\r');
    }
  }
  else if(n1 == 1 && 3 <= m && m <= 23){//list
    var reg_num = /(?:\u25cf|\u0020)(\d+)(?:\u002e|\u0020)/.exec(target.textContent)
    if(reg_num){
      if(target.textContent.indexOf(reg_num[1]) < 15)
        FireBBS.sendData(reg_num[1] + '\r\r');
    }
  }


}

function switchInputCapturer(){
  isPreventDefault = !isPreventDefault;
   if(isPreventDefault){
    document.getElementById('button01').textContent = 'Capturing ...';
    document.getElementById('button01').style.color = 'red';
  }
  else{
    document.getElementById('button01').textContent = 'Not Capturing';
    document.getElementById('button01').style.color = '';
  }
}
